// MessageQueue.h: interface for the MessageQueue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSAGEQUEUE_H__E72CEA7D_0C69_11D3_95CE_009027106653__INCLUDED_)
#define AFX_MESSAGEQUEUE_H__E72CEA7D_0C69_11D3_95CE_009027106653__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <winsock2.h>
#include <windows.h>

#define MESSAGE_QUEUE_TIMEOUT 3000

class MessageQueue  
{
public:
	struct InternalListNode
	{
		int length, from;
		void *buffer;
		InternalListNode *next;
	};
	struct InternalNode
	{
		int tag;
		InternalListNode *list;
		InternalNode *left;
		InternalNode *right;
	};

	// Construction/Destruction
	MessageQueue();
	virtual ~MessageQueue();

	// Member functions
	void* Remove(int tag, int &length, int &from);
	bool Insert(int tag, void *buffer, int length, int from);
	bool Available(int tag, int &from);
	int CountAvailable(int tag, int &from);

	// Member variables
	HANDLE m_hMutex, m_hEvent;
	InternalNode *m_pHeap;
};

#endif // !defined(AFX_MESSAGEQUEUE_H__E72CEA7D_0C69_11D3_95CE_009027106653__INCLUDED_)
