#ifndef SHMEMLOCKEDQUEUE_H
#define SHMEMLOCKEDQUEUE_H

#include "nt_tcp_shm_message_queue.h"
#include <windows.h>

#define SHMEM_Q_AVAIL_FOR_WRITE		0
#define SHMEM_Q_BEING_WRITTEN		1
#define SHMEM_Q_AVAIL_FOR_READ		2
#define SHMEM_Q_BEING_READ			3
#define SHMEM_Q_READ				4

class ShmemLockedQueue
{
public:
	struct ShmemLockedQueueHeader
	{
		int tag, from, state;
		unsigned int length;
		unsigned long next_offset;
	};

	ShmemLockedQueue();
	~ShmemLockedQueue();

	bool Init(char *name, unsigned long size);
	bool Insert(unsigned char *buffer, unsigned int length, int tag, int from);
	bool RemoveNext(unsigned char *buffer, unsigned int *length, int *tag, int *from);
	bool RemoveNextInsert(MessageQueue *pMsgQueue);

private:
	HANDLE m_hMapping;
	LONG *m_hQMutex, *m_hQEmptyEvent;//, *m_hMsgAvailableEvent;
	HANDLE m_hMsgAvailableEvent;
	LPVOID m_pBottom, m_pBase, m_pEnd;
	unsigned long m_dwSize, m_dwMaxMsgSize;
};

#endif
